#include <stdlib.h>
#include <bitset.h>


static void
test (enum bitset_type type, unsigned int bits)
{
  bitset set1;

  set1 = bitset_alloc (bits, type);

  /* Set bit outside bits of bitset to dynamically
     rebits.  */
  bitset_set (set1, bits + 1);
  bitset_reset (set1, bits + 1);

  if (!bitset_empty_p (set1))
    abort ();

  bitset_free (set1);
}


int
main (void)
{
  bitset_stats_enable ();

  test (BITSET_LIST, 4096);
  test (BITSET_TABLE, 4096);
  test (BITSET_VARRAY, 4096);

  bitset_stats_dump (stderr);
  return 0;
}
